<template>
  <ContentWrap>
    <!-- 搜索工作栏 -->
    <el-form
      class="-mb-15px"
      :model="queryParams"
      ref="queryFormRef"
      :inline="true"
      label-width="98px"
    >
      <el-form-item label="拜访人姓名" prop="customerName">
        <el-input
          v-model="queryParams.customerName"
          placeholder="请输入拜访人姓名"
          clearable
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item label="联系方式" prop="contact">
        <el-input
          v-model="queryParams.contact"
          placeholder="请输入联系方式"
          clearable
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item label="客户公司名称" prop="companyName">
        <el-input
          v-model="queryParams.companyName"
          placeholder="请输入客户公司名称"
          clearable
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item label="拜访日期" prop="visitDate">
        <el-date-picker
          v-model="queryParams.visitDate"
          value-format="YYYY-MM-DD HH:mm:ss"
          type="daterange"
          start-placeholder="开始日期"
          end-placeholder="结束日期"
          :default-time="[new Date('1 00:00:00'), new Date('1 23:59:59')]"
          class="!w-220px"
        />
      </el-form-item>
      <el-form-item label="性质等级" prop="customerStatus">
        <el-select
          v-model="queryParams.customerStatus"
          placeholder="请选择性质等级"
          clearable
          class="!w-240px"
        >
          <el-option label="请选择字典生成" value="" />
        </el-select>
      </el-form-item>
      <el-form-item label="拜访品种" prop="visitProductIds">
        <el-input
          v-model="queryParams.visitProductIds"
          placeholder="请输入拜访品种"
          clearable
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item label="拜访方式" prop="visitMethod">
        <el-select
          v-model="queryParams.visitMethod"
          placeholder="请选择拜访方式"
          clearable
          class="!w-240px"
        >
          <el-option
            v-for="dict in getIntDictOptions(DICT_TYPE.VISIT_METHOD)"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="拜访类型" prop="visitType">
        <el-select
          v-model="queryParams.visitType"
          placeholder="请选择拜访类型"
          clearable
          class="!w-240px"
        >
          <el-option
            v-for="dict in getIntDictOptions(DICT_TYPE.VISIT_TYPE)"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="创建时间" prop="createTime">
        <el-date-picker
          v-model="queryParams.createTime"
          value-format="YYYY-MM-DD HH:mm:ss"
          type="daterange"
          start-placeholder="开始日期"
          end-placeholder="结束日期"
          :default-time="[new Date('1 00:00:00'), new Date('1 23:59:59')]"
          class="!w-220px"
        />
      </el-form-item>
      <el-form-item>
        <el-button @click="handleQuery"><Icon icon="ep:search" class="mr-5px" /> 搜索</el-button>
        <el-button @click="resetQuery"><Icon icon="ep:refresh" class="mr-5px" /> 重置</el-button>
        <el-button
          type="primary"
          plain
          @click="openForm('create')"
          v-hasPermi="['visit:info:create']"
        >
          <Icon icon="ep:plus" class="mr-5px" /> 新增
        </el-button>
        <el-button
          type="danger"
          plain
          @click="handleDeleteRows()"
          v-hasPermi="['visit:info:delete']"
        >
          <Icon icon="ep:delete" class="mr-5px" /> 删除
        </el-button>
        <el-button
          type="success"
          plain
          @click="handleExport"
          :loading="exportLoading"
          v-hasPermi="['visit:info:export']"
        >
          <Icon icon="ep:download" class="mr-5px" /> 导出
        </el-button>
        <el-button
          type="success"
          plain
          @click="handlePrint"
          :loading="exportLoading"
          v-hasPermi="['visit:info:print']"
        >
          <Icon icon="ep:printer" class="mr-5px" /> 批量打印
        </el-button>
        <el-button
          type="warning"
          plain
          @click="handleUnionPrint"
          :loading="exportLoading"
          v-hasPermi="['visit:info:print']"
        >
          <Icon icon="ep:printer" class="mr-5px" /> 多选合并打印
        </el-button>
        <el-button
          type="primary"
          plain
          @click="handleUnionAllPrint"
          :loading="exportLoading"
          v-hasPermi="['visit:info:print']"
        >
          <Icon icon="ep:printer" class="mr-5px" /> 全选合并打印
        </el-button>
      </el-form-item>
    </el-form>
  </ContentWrap>

  <!-- 列表 -->
  <ContentWrap>
    <el-table v-loading="loading" :data="list" :stripe="true" :show-overflow-tooltip="true" @selection-change="handleSelectionChange">
      <el-table-column type="selection"  width="55" />
      <el-table-column label="主键ID" align="center" prop="id" />
      <el-table-column label="拜访人姓名" align="center" prop="customerName"  width="100px"/>
      <el-table-column label="联系方式" align="center" prop="contact" width="120px"/>
      <el-table-column label="客户公司名称" align="center" prop="companyName" width="240px" />
      <el-table-column label="所在地区" align="center" prop="regionFullName" width="160px" />
      <el-table-column
        label="拜访日期"
        align="center"
        prop="visitDate"
        :formatter="dateFormatter"
        width="180px"
      />
      <el-table-column label="性质等级" align="center" prop="customerStatus">
        <template #default="scope">
          <dict-tag :type="DICT_TYPE.CUSTOMER_TYPE" :value="scope.row.customerStatus" />
        </template>
      </el-table-column>
      <el-table-column label="拜访品种" align="center" prop="visitProductIds" width="100px">
        <template #default="scope">
          <ProductList :ids=scope.row.visitProductIds />
        </template>
      </el-table-column>
      <el-table-column label="拜访方式" align="center" prop="visitMethod">
        <template #default="scope">
          <dict-tag :type="DICT_TYPE.VISIT_METHOD" :value="scope.row.visitMethod" />
        </template>
      </el-table-column>
      <el-table-column label="拜访类型" align="center" prop="visitType">
        <template #default="scope">
          <dict-tag :type="DICT_TYPE.VISIT_TYPE" :value="scope.row.visitType" />
        </template>
      </el-table-column>
      <el-table-column
        label="创建时间"
        align="center"
        prop="createTime"
        :formatter="dateFormatter"
        width="180px"
      />
      <el-table-column label="操作" align="center" min-width="180px" fixed="right">
        <template #default="scope">
          <el-button
            link
            type="primary"
            @click="openForm('detail', scope.row.id)"
          >
            查看详情
          </el-button>
          <el-button
            link
            type="primary"
            @click="openForm('update', scope.row.id)"
            v-hasPermi="['visit:info:update']"
          >
            编辑
          </el-button>
          <el-button
            link
            type="danger"
            @click="handleDelete(scope.row.id)"
            v-hasPermi="['visit:info:delete']"
          >
            删除
          </el-button>
        </template>
      </el-table-column>
    </el-table>
    <!-- 分页 -->
    <Pagination
      :total="total"
      v-model:page="queryParams.pageNo"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />
  </ContentWrap>

  <!-- 表单弹窗：添加/修改 -->
  <InfoForm ref="formRef" @success="getList" />
  <!-- 打印弹窗 -->
  <Teleport to="body">
    <div v-show="false">
      <PrintContent ref="printComp" :dataList="printData" />
    </div>
  </Teleport>

</template>

<script setup lang="ts">
import {DICT_TYPE, getIntDictOptions} from '@/utils/dict'
import {dateFormatter} from '@/utils/formatTime'
import download from '@/utils/download'
import {InfoApi, InfoVO} from '@/api/visit/info'
import InfoForm from './InfoForm.vue'
import ProductList from "@/views/visit/util/ProductList.vue";
import {useRoute} from 'vue-router'


import {usePrint} from '../util/print'
import PrintContent from '../util/PrintContent.vue'

//==========
const printData = ref([])

const printComp = ref()

const handlePrint = async () => {
  if (multipleSelection.value.length === 0) {
    return message.warning('请先选择需要打印的记录')
  }
  printData.value = await InfoApi.getPrintListByIds(multipleSelection.value.join(','))
  await nextTick()
  const dom = printComp.value.printRef
  if (dom) usePrint(dom)
}
const handleUnionPrint = async () => {
  if (multipleSelection.value.length === 0) {
    return message.warning('请先选择需要合并打印的记录')
  }
  printData.value = await InfoApi.getUnionPrintListByIds(multipleSelection.value.join(','))
  await nextTick()
  const dom = printComp.value.printRef
  if (dom) usePrint(dom)
}
const handleUnionAllPrint = async () => {
  if (list.value.length === 0) {
    return message.warning('当前不存在可打印数据')
  }
  printData.value = await InfoApi.getUnionAllPrintListByIds(queryParams)
  await nextTick()
  const dom = printComp.value.printRef
  if (dom) usePrint(dom)
}

// 模拟获取详情数据的方法（你应该调 InfoApi.getInfoListByIds 或类似接口）

const route = useRoute()

/** 客户拜访记录 列表 */
defineOptions({ name: 'Info' })

const message = useMessage() // 消息弹窗
const { t } = useI18n() // 国际化

const loading = ref(true) // 列表的加载中
const list = ref<InfoVO[]>([]) // 列表的数据
const total = ref(0) // 列表的总页数
const queryParams = reactive({
  pageNo: 1,
  pageSize: 10,
  customerName: undefined,
  contact: undefined,
  companyName: undefined,
  visitDate: [],
  customerStatus: undefined,
  visitProductIds: undefined,
  visitMethod: undefined,
  visitType: undefined,
  createTime: [],
})
const queryFormRef = ref() // 搜索的表单
const exportLoading = ref(false) // 导出的加载中
const multipleSelection = ref([])  //存储多选内容

/** 多选操作**/
const handleSelectionChange = (val) => {
  multipleSelection.value = val.map(item=>item.id)
  //console.log(val,multipleSelection)
}
/** 查询列表 */
const getList = async () => {
  loading.value = true
  try {
    const data = await InfoApi.getInfoPage(queryParams)
    list.value = data.list
    total.value = data.total
  } finally {
    loading.value = false
  }
}

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.pageNo = 1
  getList()
}

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value.resetFields()
  handleQuery()
}

/** 添加/修改/查看操作 */
const formRef = ref()
const openForm = (type: string, id?: number) => {
  formRef.value.open(type, id)
}

/** 删除按钮操作 */
const handleDelete = async (id: number) => {
  try {
    // 删除的二次确认
    await message.delConfirm()
    // 发起删除
    await InfoApi.deleteInfo(id)
    message.success(t('common.delSuccess'))
    // 刷新列表
    await getList()
  } catch {}
}

/** 批量删除按钮操作 */
const handleDeleteRows = async () => {
  try {
    if (multipleSelection.value.length === 0) {
      return message.warning('请先选择需要删除的记录')
    }
    // 删除的二次确认
    await message.delConfirm()
    // 发起删除
    await InfoApi.deleteInfoByIds(multipleSelection.value.join(','))
    message.success(t('common.delSuccess'))
    // 刷新列表
    await getList()
  } catch {}
}

/** 导出按钮操作 */
const handleExport = async () => {
  try {
    // 导出的二次确认
    await message.exportConfirm()
    // 发起导出
    exportLoading.value = true
    const data = await InfoApi.exportInfo(queryParams)
    download.excel(data, '客户拜访记录.xls')
  } catch {
  } finally {
    exportLoading.value = false
  }
}

/** 初始化 **/
onMounted(() => {
  const companyName = route.query.companyName
  if (companyName){
    queryParams.companyName = companyName
  }
  getList()
})
</script>
